﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using devDept.Eyeshot;

namespace WindowsApplication1
{
    class MyViewportLayout : ViewportLayout
    {
        protected override int[] GetVisibleEntitiesFromBackBuffer<T>(IList<T> entList, Viewport viewport, Rectangle selectionBox, bool firstOnly)
        {
            if (entList != Entities)

                return base.GetVisibleEntitiesFromBackBuffer(entList, viewport, selectionBox, firstOnly);

            // Reads the visible Quads from the back buffer and selects them
            for (int i = 0; i < entList.Count; i++)
            {
                if (entList[i] is MyMesh)
                {
                    MyMesh myMesh = entList[i] as MyMesh;
                    int[] indices = base.GetVisibleEntitiesFromBackBuffer(entList, viewport, selectionBox, firstOnly);

                    // Select the quads
                    myMesh.SelectQuads(indices);
                    break;
                }
            }

            return new int[0];
        }
    }
}
